export const isObject = item => {
  return !!(item && typeof item === 'object' && !Array.isArray(item) && item !== null)
}

export const deepMerge = (target, source, options = {}) => {
  let obj = {...target} // clones target

  Object.keys(source).forEach(key => {
    const sourceValue = source[key]

    if (Array.isArray(sourceValue)) {
      if (options.noArrayMerge) {
        obj[key] = [...sourceValue] // clone array
      } else {
        obj[key] = [...(obj[key] || []), ...sourceValue] // clone merge array
      }
    } else if (isObject(sourceValue)) {
      obj[key] = deepMerge(obj[key] || {}, sourceValue, options)
    } else {
      obj[key] = sourceValue
    }
  })

  return obj
}
