import webpack           from 'webpack'
import PostCompilePlugin from 'post-compile-webpack-plugin'
import stats             from './stats'

export default config => {
  return {
    devtool: 'inline-source-map',

    output: {
      filename: '[name].js',
      sourceMapFilename: '[name].map'
    },

    plugins: [
      new webpack.NoEmitOnErrorsPlugin(),
      new webpack.HotModuleReplacementPlugin(),
      new PostCompilePlugin(stats(config))
    ]
  }
}
